/*****************************************************************************
 *  File: main.c
 * 
 *  This file is the top level of the application selector.
 *
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h> 
#include <sys/alt_alarm.h>
#include "app_selector.h"
#include "alt_video_display.h"
#include "my_ui.h"
#include "system.h"
#include "io.h"

#include "terasic_includes.h"
#include "I2C.h"
#include "ADXL345.h"
#include "math.h"


int main()
{

  volatile int ret_code;

  // This is our LCD display
  alt_video_display* display;

 // Initialize and start the LCD display
  display = alt_video_display_init( ALT_VIDEO_DISPLAY_SGDMA_NAME,         // char* sgdma_name
                                    ALT_VIDEO_DISPLAY_COLS,               // int width
                                    ALT_VIDEO_DISPLAY_ROWS,               // int height
                                    ALT_VIDEO_DISPLAY_COLOR_DEPTH,        // int color_depth
                                    ALT_VIDEO_DISPLAY_USE_HEAP,           // int buffer_location
                                    ALT_VIDEO_DISPLAY_USE_HEAP,           // int descriptor_location
                                    2 );                                  // int num_buffers                                  // int num_buffers
                                     

   // Set the Gamma Curve and Resolution of the LCD  
  Gsensor_init();
  set_range(0x10);
  //lcd direction
  IOWR(LCD_LEFT_RIGHT_BASE, 0, 1);
  IOWR(LCD_UP_DOWN_BASE, 0, 0);
  
  my_ui(display);  

  return ( ret_code );
}